<?xml version="1.0" encoding="windows-1250"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:UML="org.omg/UML1.3"
	xmlns:xalan="http://xml.apache.org/xalan"
    exclude-result-prefixes="xalan"
	version="1.0">

<xsl:output indent="yes" method="xml" encoding="utf-8"/>
<xsl:param name="multiplier" select="4"/>

<xsl:template match="XMI.content">
	<xsl:copy>
		<xsl:apply-templates select="@*|node()"/>
    	<UML:DataType xmi.id = 'G.6' name = 'java.util.Vector' visibility = 'public' isSpecification = 'false'/>
	</xsl:copy>
</xsl:template>
<xsl:template match="UML:Class/UML:Classifier.feature">
	<xsl:copy>
    	<xsl:apply-templates select="@*|node()"/>
		<xsl:apply-templates select="//UML:AssociationEnd[UML:AssociationEnd.type/*/@xmi.idref= current()/../@xmi.id]" mode="assoc"/>
	</xsl:copy>
</xsl:template>

<xsl:template match="UML:AssociationEnd" mode="assoc">
	<!-- Druha strana -->
	<xsl:variable name="role">
		<xsl:choose>
			<xsl:when test="following-sibling::UML:AssociationEnd">
				<xsl:value-of select="following-sibling::UML:AssociationEnd/@name"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="preceding-sibling::UML:AssociationEnd/@name"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="type_id">
		<xsl:choose>
			<xsl:when test="following-sibling::UML:AssociationEnd">
				<xsl:value-of select="following-sibling::UML:AssociationEnd/UML:AssociationEnd.type/*/@xmi.idref"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="preceding-sibling::UML:AssociationEnd/UML:AssociationEnd.type/*/@xmi.idref"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="card">
		<xsl:choose>
			<xsl:when test="following-sibling::UML:AssociationEnd">
				<xsl:value-of select="following-sibling::UML:AssociationEnd/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="preceding-sibling::UML:AssociationEnd/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:if test="$role and $role != ''">
		<UML:Attribute xmi.id = '{generate-id()}'
			name = '{$role}' visibility = 'private' isSpecification = 'false'
            	changeability = 'changeable' ownerScope = 'instance'>
       		<UML:StructuralFeature.multiplicity>
        		<UML:Multiplicity>
         			<UML:Multiplicity.range>
          				<UML:MultiplicityRange lower = '1' upper = '1'/>
         			</UML:Multiplicity.range>
        		</UML:Multiplicity>
       		</UML:StructuralFeature.multiplicity>
       		<UML:StructuralFeature.type>
				<xsl:choose>
					<xsl:when test="$card='unlimited'">
						<Foundation.Core.Classifier xmi.idref = 'G.6'/>
					</xsl:when>
					<xsl:otherwise>
						<Foundation.Core.Classifier xmi.idref = '{$type_id}'/>
					</xsl:otherwise>
				</xsl:choose>
       		</UML:StructuralFeature.type>
            <UML:ModelElement.taggedValue>
				<UML:TaggedValue tag="associates"> 
					<xsl:attribute name="value">&lt;{<xsl:value-of select="//*[@xmi.id = $type_id]/@name"/>}&gt;</xsl:attribute>
				</UML:TaggedValue>
            </UML:ModelElement.taggedValue>
      	</UML:Attribute>
	</xsl:if>
</xsl:template>

<xsl:template match="UML:AssociationEnd">
	<xsl:copy>
		<xsl:apply-templates select="@*|node()"/>
		<!-- Druha strana -->
		<xsl:variable name="bratr">
			<xsl:choose>
				<xsl:when test="following-sibling::UML:AssociationEnd">
					<xsl:value-of select="following-sibling::UML:AssociationEnd/@name"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="preceding-sibling::UML:AssociationEnd/@name"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$bratr and $bratr!=''">
			<UML:AssociationEnd.qualifier>
				<UML:Attribute xmi.idref = '{generate-id()}'/>
			</UML:AssociationEnd.qualifier>
		</xsl:if>
	</xsl:copy>
</xsl:template>

<!-- zkopiruj -->
<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet>

